
//operation above map structures

#ifndef SIRIEL_LEVEL
#define SIRIEL_LEVEL


using namespace std;

extern "C" {
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
}

#include <string>
#include <map>
#include <deque>
#include <cstdio>
#include <iostream>

#include "cl_datadisc.h"
#include "cl_luawrapper.h"
#include "si_config.h"
#include "si_graphics.h"
#include "si_string.h"
#include "si_system.h"
#include "define.h"
#include "variable.h"


class LEVEL
{
	private:
		DATADISC		*disk;		
		map<string, string> 	data;
		BITMAP			 *scrbuf;
		BITMAP			 *mapbmp;
		BITMAP 			*backbmp;
		int	*bin_map;		//binary image of map
		int	*back_map;
		string 	filename;
		char	obj_lowest_char; //lower bound
		int	texture_w, texture_h;	//parameters of one texture
		int	map_w, map_h;		//size of one map
		int	render_background;	//falg of rendering
		int 	canvas_x, canvas_y;

	public:
		void init();
		void done();

		void create_map();
		void destroy_map();
		int  set_map_line(int i, string data);
		void set_back_line(int i, string data);

		void print_text_map();		//print full map as text
		void print_text_bgmap();		//print full map as text
		void print_map(int x, int y);	//print only one texture on x,y
		void print_map();		//print full actual map
		void render_map();		//print map into internal memory
		void print_internal_map(int x, int y);	//print one texture into
							//internal mem
		void bg_from_file(string name);
		
		void map_dimension(int x, int y);
		void texture_dimension(int x, int y);

		void lowest_char(char c);
		char lowest_char();
		void render();
	
		void middle_map(deque<string> l);
		void background_map(deque<string> l);
		void set_textures(deque<BITMAP *> &txt);
		void set_datadisc(DATADISC *d);
		void set_drawing(BITMAP *bmp);
		void set_filename(string fname);
		string get_filename();

		int walkable(int x, int y);

};

#define lua_register(L,n,f) \
(lua_pushstring(L, n), \
 lua_pushcfunction(L, f), \
 lua_settable(L, LUA_GLOBALSINDEX))


#endif


