//Middle level class

#include "mi_level.h"

void MI_LEVEL::init()
{
	alevel = NULL;
	object = NULL;
	def_lev_name = "";
}

void MI_LEVEL::canvas(BITMAP *b)
{
	scr = b;
}

void MI_LEVEL::connect_object(MI_OBJECT *o)
{
	object = o;
}


int MI_LEVEL::create(string name)
{
	LEVEL *lev;
	lev = new LEVEL;
	lev->init();
	lev->set_drawing(scr);
	lev->set_datadisc(adatasrc);
	level[name] = lev;
	actual(lev);
	object->connect_level(level[name]);
	return 0;
}


void MI_LEVEL::actual(LEVEL *l)
{
	alevel = l;
	object->actual_level(l);
}

void MI_LEVEL::connect_datasrc(DATADISC *d)
{
	adatasrc = d;
	if(alevel) {
		alevel->set_datadisc(d);
	}
}

void MI_LEVEL::draw()
{
	if(alevel) {
		alevel->print_map();
	} else {
		error("Unable to draw content of not existing level");
	}
}

/*void MI_LEVEL::set_actual(string lname)
{
	alevel = level[lname];
}*/


void MI_LEVEL::set_file(string lname, string fname)
{
	level[lname]->set_filename(fname);
}

string MI_LEVEL::implicit()
{
	return def_lev_name;
}

string MI_LEVEL::implicit_fname()
{
	if(!level[def_lev_name]) {
		error("Trying to get filename from not existing level");
		return "";
	}
	return level[def_lev_name]->get_filename();
}

void MI_LEVEL::implicit(string lname)
{
	alevel = level[lname];
	def_lev_name = lname;
	object->connect_level(level[lname]);	//connect all objects created before this level
}

void MI_LEVEL::render()
{
	alevel->render();
}

void MI_LEVEL::zero(char c)
{
	alevel->lowest_char(c);
}

void MI_LEVEL::map_dimension(int x, int y)
{
	alevel->map_dimension(x,y);
}

void MI_LEVEL::middle_map(deque<string> l)
{
	alevel->middle_map(l);
}

void MI_LEVEL::background_map(deque<string> l)
{
	alevel->background_map(l);
}

void MI_LEVEL::print_text_maps()
{
	alevel->print_text_map();
	alevel->print_text_bgmap();
}
