
#ifndef CLASS_MI_LEVEL
#define CLASS_MI_LEVEL

#include <string>
#include <map>
#include <deque>

#include <allegro.h>

#include "cl_level.h"
#include "cl_datadisc.h"

#include "mi_object.h"

using namespace std;

class MI_LEVEL
{
	map<string, LEVEL *>	level;	//all levels available in game
	LEVEL 			*alevel;
	string			def_lev_name;	//default level name
	MI_OBJECT		*object;
	BITMAP			*scr;
	DATADISC		*adatasrc;

	public:
	void init();
	void canvas(BITMAP *b);
	void connect_object(MI_OBJECT *o);
	
	int create(string name);
	void actual(LEVEL *l);
	void connect_datasrc(DATADISC *d);
	void draw();
	void actual_level(string lname);
	void set_file(string lname, string fname);
	string implicit();
	string implicit_fname();
	void implicit(string lname);
	void render();

	void zero(char c);
	void map_dimension(int x, int y);
	void middle_map(deque<string> l);
	void background_map(deque<string> l);
	void print_text_maps();


};

#endif

