
#include "cl_engine.h"

void ENGINE::init()
{
	anim.init();
	object.init();
	music.init();
	panel.init();
	event.init();
	sound.init();
	widget.init();
	data.init();
	rooms.init();
	stage.init();
	object.connect_event(&event);
	object.connect_panel(&panel);
	object.connect_stage(&stage);
	anim.connect_object(&object);
	data.connect_anim(&anim);
//	data.connect_level(&level);
	stage.connect_rooms(&rooms);
//	stage.connect_data(&data);
}

void ENGINE::done()
{
	stage.destroy_layers();
	delete_console();
}

void ENGINE::canvas(BITMAP *b)
{
	scr = b;
	panel.canvas(b);
	widget.canvas(b);
	object.canvas(b);
//	level.canvas(b);
	stage.canvas(b);
	stage.create_layers();
}



