
#ifndef SIRIEL_LUA
#define SIRIEL_LUA

extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

#include <string>
#include <map>

#include "si_wrapper.h"
#include "si_system.h"

#include "define.h"

class LUA_WRAPPER
{
	private:
	lua_State *lstate;
	map <string, string> help_data;
	map <string, string> help_desc;
	public:
	void init();
	void done();

	void reg(int (*f)(lua_State*), const char *name);
	void reg(const char *name, int (*f)(lua_State*));
	void reg(int (*f)(lua_State*), const char *name, string dsc, string hlp);
	void reg(const char *name, int (*f)(lua_State*), string dsc, string hlp);
	//register function

	int get_int(char *name);
	const char *get_str(char *name);
	const char *get_str(char *name, int index);
	
	void dofile( const char * filename );
	int do_alleg_file(string fname);
	void exec(char *cmd);

	string list_functions();
	string list_desc_functions();
	string help_function(string s);

	int argc();
	string get_str();
	int get_int();
};

#endif

