
#ifndef CLASS_SCRIPT
#define CLASS_SCRIPT

#include <string>
#include <map>
#include <deque>


#include "define.h"
#include "help.h"

#include "cl_engine.h"
#include "cl_luawrapper.h"
#include "cl_event.h"

#define HELP_FILE "main.dat#help"

using namespace std;

class SCRIPT
{	
	ENGINE		*engine_internal;	//pointer to existing engine
	int		status;
	EVENT_DRIVER	*event;
	public:
	LUA_WRAPPER	*lua;

	void init();
	void connect_engine(ENGINE *e);
	void connect_luawrapper(LUA_WRAPPER *l);
	void connect_event(EVENT_DRIVER *ev);
	void register_functions();
	void import(string s);
	void load_data();

	void mode(int i);
	int mode();
};


void create_object(string name, map< string,int > numbers, map< string, string > strings);
int create_object(lua_State *l);
int destroy_object(lua_State *l);
int destroy_all_objects(lua_State *l);
int rem(lua_State *l);	//good old Basic :)
int modify_xy(lua_State *l);
//int create_level(lua_State *l);
//int default_level(lua_State *l);
int set_datasrc(lua_State *l);
int open_anim(lua_State *l);
int load_anim(lua_State *l);
int close_anim(lua_State *l);
int set_anim_as_texture(lua_State *l);
int game_type(lua_State *l);
int play_music(lua_State *l);
int stop_music(lua_State *l);
int load_sound(lua_State *l);
int play_sound(lua_State *l);
int echo(lua_State *l);
int exec(lua_State *l) ;
int reg(lua_State *l);
int create_widget(lua_State *l);
int message(lua_State *l);
int kill_engine(lua_State *l);
int set_avatar(lua_State *l);
int map_zero(lua_State *l);
//int map_dimension(lua_State *l);
//int middle_map(lua_State *l);
//int background_map(lua_State *l);
int help(lua_State *l);
int tile_list(lua_State *l);

void import_datafile(const char *filename, int attrib, int param);
DATASRC *info_datafile(string filename, string fname);

int redraw(lua_State *l);
//int printmap(lua_State *l);

int cmd_expand(lua_State *l);
int cmd_noexpand(lua_State *l);
int version(lua_State *l);
int author(lua_State *l);

int change_room(lua_State *l);
int create_room(lua_State *l);
void create_room(string name, map< string,int > &numbers, map< string, string > &strings,
		map< string, deque<string> > &tables);


#endif


