//Stage control

#ifndef SIRIEL_CLASS_STAGE
#define SIRIEL_CLASS_STAGE

#include <allegro.h>

#include "define.h"

#include "cl_datadisc.h"
#include "cl_room.h"

#include "mi_room.h"

#include "define.h"

#define DISPLAY_LAYER	0
#define FOREGROUND_LAYER 2

using namespace std;

class STAGE
{
	DATADISC		*disk;
//	MI_DATASRC		*data;
	BITMAP			*scr;
	BITMAP			*layer[ROOM_LAYERS];
	int			empty_layer[ROOM_LAYERS];
	int			canvas_w, canvas_h;
	int			tile_cw, tile_ch;
	int			tile_w, tile_h;
	MI_ROOM			*rooms;
	int			layers_exists;
	string			rn;	//room name
	public:

	void init();
	void canvas(BITMAP *b);
	void connect_rooms(MI_ROOM *d);
	void connect_data(DATADISC *d);
	//void connect_data(MI_DATASRC *d);

	void clear_layer(int i);
	void create_layers();
	void destroy_layers();

	int walkable(int x, int y);
	int draw();
	int draw_foreground();

	int select(string name);	// select room from database as implicit
	string room_name();
	void render();
	void render_layer(int l);
	void merge_layer(int src, int dst);	//merge two different layers into one
	int render_internal(int l, int x, int y);

	void tile_list();	//display list of tiles and approp. keys
	int tile_count();	//return no. of pressent tiles
};

#endif

