//Middle level for animation

#include "mi_anim.h"

void MI_ANIM::init()
{
	aimage = NULL;
	object = NULL;
}

void MI_ANIM::actual_datasrc(DATADISC *d)
{
	adatasrc = d;
}

void MI_ANIM::connect_object(MI_OBJECT *o)
{
	object = o;
}


int MI_ANIM::create(string name)
{
	ANIM *movie;
	movie = new ANIM;
	movie->init();
	image[name] = movie;
	actual(movie);
	return 0;
}


void MI_ANIM::actual(ANIM *b) //require interface on higher level
{
	aimage = b;
	object->actual_image(b);
}


void MI_ANIM::open(string name, string fname, int sizex, int sizey)
{
	opened_image = name;
	cout << "Try to open"<< endl;
	cout << "Opening image[" << name << "]:"<< adatasrc->filename() << " - " << fname << endl;
	image[opened_image]->open(adatasrc->filename(), fname, sizex, sizey);
}

void MI_ANIM::load(string name, int x1, int y1, int x2, int y2)
{
	image[opened_image]->load(name, x1, y1, x2, y2);
}

void MI_ANIM::close(string name)
{
	image[opened_image]->close();
	opened_image = "";
}

void MI_ANIM::set_as_texture(string name, string aname)
{
	adatasrc->set_textures(image[name]->getanimrow(aname));
}

ANIM *MI_ANIM::get(string name)
{
	return image[name];
}


