//Middle widget class

#include "mi_widget.h"

void MI_WIDGET::canvas(BITMAP *bmp)
{
	scr = bmp;
}

void MI_WIDGET::init()
{
	scr = NULL;
	widget.clear();
	awidget = NULL;
}



void MI_WIDGET::create(string s)
{
	WIDGET *w;
	w = new WIDGET;
	w->init();
	w->canvas(scr);
	widget[s] = w;

	if(s == DEFAULT_WIDGET) {
		awidget = w;
#ifdef HARD_DEBUG
		message("Using as default widget");
#endif
	}
}


void MI_WIDGET::draw(string s)
{
	if(widget[s]) {
		widget[s]->draw();
	} else {
		error("Widged %s doesn't exist", s.c_str());
	}
}

void MI_WIDGET::draw()
{
	awidget->draw();
}

void MI_WIDGET::draw_all()
{
	map<string, WIDGET *>::iterator i;

	for(i=widget.begin(); i!=widget.end(); i++) {
		i->second->draw_visible();
	}
}

void MI_WIDGET::message(string s)
{
	awidget->content(s);
	awidget->show();
}

void MI_WIDGET::message(string t,string s)
{
	awidget->title(t);
	awidget->content(s);
	awidget->show();
}

void MI_WIDGET::show()
{
	awidget->show();
}

void MI_WIDGET::hide()
{
	awidget->hide();
}

void MI_WIDGET::hide_all()
{
	map<string, WIDGET *>::iterator i;

	for(i=widget.begin(); i!=widget.end(); i++) {
		i->second->hide();
	}
}

void MI_WIDGET::property(string name, int val)
{
	awidget->property(name, val);
}

void MI_WIDGET::property(string wname, string name, int val)
{
	widget[wname]->property(name,val);
}


